#define	A	26
#define	B	52
#define	LAMBDA	808

process count = 11; /* 1 is for ring, the others for stations. */ 
local clock x;
global synchronizer begin, end, cd, busy; 

mode bus_idle true { 
	when ?begin true  may x= 0; goto bus_active; /* 1 */
}

mode bus_active true { 
	when ?end true  may x= 0; goto bus_idle; /* 2 */
	when !busy x >= A may ; /* 3 */
	when ?begin x < A  may x= 0; goto bus_collision; /* 4 */
}

mode bus_collision x < A { 
	when !cd !cd !cd !cd !cd !cd !cd !cd !cd !cd x < A  may x= 0; goto bus_idle; /* 5 */
}


mode sender_wait true {
	when !begin true may x= 0; goto sender_transm; /* 6 */
	when ?cd true may x= 0; /* 7 */
	when ?cd true may x= 0; goto sender_retry; /* 8 */
	when ?busy true may x= 0; goto sender_retry; /* 9 */
}  

mode sender_transm x <= LAMBDA { 
	when !end x==LAMBDA may x= 0; goto sender_wait; /* 10 */
	when ?cd x<B may x= 0; goto sender_retry; /* 11 */
} 

mode sender_retry x < B {
	when !begin x < B may x= 0; goto sender_transm; /* 12 */ 
	when ?cd x < B may x= 0; /* 13 */
}



initially 
    bus_idle[1] and x[1] == 0  
and sender_wait[2] and x[2] == 0  
and sender_wait[3] and x[3] == 0 
and sender_wait[4] and x[4] == 0 
and sender_wait[5] and x[5] == 0 
and sender_wait[6] and x[6] == 0 
and sender_wait[7] and x[7] == 0
and sender_wait[8] and x[8] == 0
and sender_wait[9] and x[9] == 0 
and sender_wait[10] and x[10] == 0
and sender_wait[11] and x[11] == 0;
 

risk 
    sender_transm[2] and sender_transm[3] and (x[2] >= A or x[3] >= A);
