#define	A	26
#define	B	52
#define	LAMBDA	808

process count = 4; /* 1 is for ring, the others for stations. */
global synchronizer begin, end, cd, busy;

module bus {
  local clock x;

  mode idle true {
	when ?begin true  may x= 0; goto active; /* 1 */
  }

  mode active true {
	when ?end true  may x= 0; goto idle; /* 2 */
	when !busy x >= A may ; /* 3 */
	when ?begin x < A  may x= 0; goto collision; /* 4 */
  }

  mode collision x < A {
	when !cd !cd !cd x < A  may x= 0; goto idle; /* 5 */
  }
}
  /* module bus */


module sender {
  local clock x;

  mode wait true {
	when !begin true may x= 0; goto transm; /* 6 */
	when ?cd true may x= 0; /* 7 */
	when ?cd true may x= 0; goto retry; /* 8 */
	when ?busy true may x= 0; goto retry; /* 9 */
  }

  mode transm x <= LAMBDA {
	when !end x==LAMBDA may x= 0; goto wait; /* 10 */
	when ?cd x<B may x= 0; goto retry; /* 11 */
  }

  mode retry x < B {
	when !begin x < B may x= 0; goto transm; /* 12 */
	when ?busy true may x= 0; /* 13 */
	when ?cd x < B may x= 0; /* 14 */
  }
}
  /* module sender */



initially
    bus.idle[1] && bus.x[1] == 0 and forall i:i>1, (sender.wait[i] and bus.x[i] == 0);


risk
    sender.transm[2] and sender.transm[3] and
(sender.x[2] >= B or sender.x[3] >= B)
;

