/* Fischer's protocol with 2 processes */ 
process count = 2;

global pointer lock; 

local clock x; 

mode idle true {
  when lock == NULL may x= 0; goto ready; 
}

mode ready true {
  when x < 10 may x= 0; lock= P; goto waiting; 
}

mode waiting true { 
  when (x > 19 and lock == P) may goto critical; 
  when lock != P may goto idle; 
}

mode critical true { 
  when true may lock = NULL; goto idle; 
} 

initially 
lock == NULL and forall i, (idle[i] and x[i] == 0); 

specification 
exists eventually exists i, (ready[i] and forall j, exists always not critical[j]);


