#define TRUE 1
#define FALSE 0 

#define GREEN 0
#define AMBER 1
#define RED 2
#define UP 0
#define DOWN 1
#define PRILOW 0
#define PRIHIGH 1

process count=4;
global discrete length:0..10;
global discrete light:0..2;
global discrete gate:0..1;
global discrete error;
global discrete car;
local clock x, y;
global synchronizer enter_near,enter_far;

mode train_far true{
     when !enter_near true may x=0; goto train_near;
}

mode train_near x<200{
     when x >=150 and x<200 may goto train_crossing;
}

mode train_crossing true{
     when !enter_far true may x=0; goto train_far;
}

/*** gate monitor-controller **************/

mode c_up true {
	when ?enter_near true may x= 0 ; gate = DOWN ; goto c_move_down;
}

mode c_move_down x <= 50 {
	when x <= 50 may goto c_down;
}

mode c_down true {
	when ?enter_far true may x= 0; gate = UP ; goto c_move_up;
}

mode c_move_up x <= 100 {
	when x<= 100 may goto c_up;
	when ?enter_near true may x= 0 ; gate = DOWN ; goto c_move_down;
}

/*** highway traffic controller ************/

mode green x<=100 {
	when x==100 and car == PRILOW may x = 0;light = AMBER ; goto amber;
	when x==100 and car==PRIHIGH may x = 0 ;light = GREEN; goto greenextend;
}

mode greenextend x<=20{
        when x==20 and car==PRILOW may x=0;light = AMBER; goto amber;
        when x==20 and car==PRIHIGH may x=0;
}

mode amber x<=5 {
	when x==5 may x = 0; light = RED ; goto red;
}

mode red x<=100 {
	when x==100 and car==PRILOW may x=0; light = GREEN; goto green;
	when x<=100 and car==PRIHIGH may x=0; light = GREEN; goto green;

}

/*** car_priority************************/

mode car_priority true{
        when (x>=5 and x<10) may x=0; car=PRILOW;
        when (x>=50 and x<150) may x=0; car=PRIHIGH;
}

/***  road ******************************/

mode road(x<=10 and y<=10) {
	when x>=5 and x<10 and gate==UP and length<10 may x = 0; length++1;
	when x>=5 and x<10 and gate==UP and length==10 may x = 0; error= TRUE;
	when y>=5 and x<10 and light==GREEN and length>0 may y= 0; length--1;
}

initially
      error == FALSE and light == GREEN and gate == UP and length == 0
and train_far[1] and x[1] == 0 and light == 0
and c_up[2] and x[2] == 0
and green[3] and x[3] == 0
and road[4] and x[4] == 0 and y[4] == 0;


risk
       c_down[2] and error==TRUE;
