#define TRUE 1
#define FALSE 0

#define GREEN 0
#define AMBER 1
#define RED 2
#define UP 0
#define DOWN 1


process count=5;
global discrete length:0..10;
global discrete light:0..2;
global discrete gate:0..1;
global discrete error:0..1;
local clock x, y;
global synchronizer enter_near,enter_far,leng_inc, leng_dec,
                    change2amber,change2red,change2green,change2redextend;

mode train_far true{
     when !enter_near true may x=0; goto train_near;
}

mode train_near x<200{
     when x >=150 and x<200 may goto train_crossing;
}

mode train_crossing true{
     when !enter_far true may x=0; goto train_far;
}

/*** gate monitor-controller **************/

mode c_up true {
	when ?enter_near true may x= 0 ; gate = DOWN ; goto c_move_down;
}

mode c_move_down x <= 50 {
	when x <= 50 may goto c_down; 
}

mode c_down true { 
	when ?enter_far true may x= 0; gate = UP ; goto c_move_up; 
}

mode c_move_up x <= 100 { 
	when x<= 100 may goto c_up; 
	when ?enter_near true may x= 0 ; gate = DOWN ; goto c_move_down; 
}

/*** highway traffic controller ************/

mode green x<=100 {
	when x==100 may x = 0;light = AMBER ; goto amber;
	when ?change2amber true may x = 0 ;light = AMBER; goto amber;
}

mode amber x<=5 {
	when x==5 may x = 0; light = RED ; goto red;
        when ?change2red true may x=0; light=RED; goto red;
        when ?change2green true may x=0;light=GREEN; goto green;
}

mode red x<=100 {
	when ?change2redextend true may x=0; light = RED; goto redextend;
}

mode redextend x<=30 {
        when x==30 may x=0; light=GREEN; goto green;
}

/*** counter************************/

mode idle true{
        when ?leng_dec length==1 may x=0; goto count;
        when ?leng_dec true may x=0;
        when ?leng_inc true may x=0; 
}

mode count x<=7{
        when ?leng_inc true may x=0;goto idle;
        when !change2amber x==7 and light==GREEN may x=0;goto idle;
        when x==7 and light==AMBER may x=0;goto idle;
        when !change2redextend x==7 and light==RED may x=0; goto idle;
}

/***  road ******************************/

mode road(x<=50 and y<=50) {
	when !leng_inc x>=5 and x<50 and gate==UP and length<10 may x = 0; length++1; 
	when x>=5 and x<50 and gate==UP and length==10 may x = 0; error= TRUE;
	when !leng_dec y>=5 and y<50 and light==GREEN and length>0 may y= 0; length--1; 
}


initially
      light == GREEN and gate == UP and length == 0
and train_far[1] and x[1] == 0 
and c_up[2] and x[2] == 0
and green[3] and x[3] == 0
and idle[4] and x[4]==0
and road[5] and x[5]==0 and y[5]==0;


risk
       c_down[2] and error==TRUE;
