#define TRUE 1
#define FALSE 0

#define GREEN 0
#define AMBER 1
#define RED 2
#define UP 0
#define DOWN 1

process count=4;
global discrete length:0..10;
global discrete light:0..2;
global discrete gate:0..1;
local clock x, y;
global synchronizer enter_near,enter_far;

mode train_far true{
     when !enter_near true may x=0; goto train_near;    /*(1,1)*/
}

mode train_near x<150{
     when x<150 may x=0; goto train_crossing;             /*(1,2)*/
}

mode train_crossing true{
     when !enter_far true may x=0; goto train_far;        /*(1,3)*/
}

/*** gate monitor-controller **************/

mode c_up true {
	when ?enter_near true may x= 0; goto c_move_down;      /*(2,4)*/
}

mode c_move_down x <= 10 {
	when x == 10 may gate = DOWN; x=0; goto c_down;         /*(2,5)*/
}

mode c_down true {
	when ?enter_far true may gate = UP; x= 0; goto c_move_up;   /*(2,6)*/
}

mode c_move_up x <= 100 {
	when x== 100 may goto c_up;                    /*(2,7)*/
	when ?enter_near true may gate = DOWN; x= 0; goto c_move_down;     /*(2,8)*/
}

/*** highway traffic controller ************/

mode green x<=100 {
	when x==100 may x=0; goto amber;           /*(3,9)*/
}

mode amber x<=5 {
	when x==5 may x=0; goto red;
}

mode red x<=100 {
	when x==100 may x=0; goto green;
}

/***  road ******************************/

mode road(x<=10 and y<=10) {
	when x>=5 and x<10 and gate==UP and length<10 may x = 0; length++1;
	when x>=5 and x<10 and gate==DOWN and length<10 may x=0;
	when x<5 and gate==UP and length<10 may x=0;
	when x<5 and gate==DOWN and length<10 may x=0;
	when y>=5 and x<10 and light==GREEN and length>0 may y= 0; length--1;
	when y>=5 and x<10 and light==AMBER and length>0 may y=0;
	when y>=5 and x<10 and light==RED and length>0 may y=0;
	when y<5 and light==GREEN and length>0 may y=0;
	when y<5 and light==AMBER and length>0 may y=0;
	when y<5 and light==RED and length>0 may y=0;
}

initially
      light == GREEN and gate == UP and length == 0
and train_far[1] and x[1] == 0
and c_up[2] and x[2] == 0
and green[3] and x[3] == 0
and road[4] and x[4] == 0 and y[4] == 0;


risk
       c_down[2] and length==10;
