#define	PERIOD		2
#define DEADLINE	4 /* the ceiling of log PC */ 


process count = 12; 
global clock 		time; 
local clock 		x; 
global pointer 		request_pid, respond_pid; 
local pointer 		parent; 
global synchronizer	request_parent; 

mode idle parent != NULL || x <= PERIOD { 
	when !request_parent 
	x <= PERIOD && request_pid == NULL && parent == NULL 
		may x= 0; request_pid = P; goto connecting_request; /* 1 */
	when ?request_parent 
	x <= PERIOD && respond_pid == NULL && parent == NULL 
		may x= 0; respond_pid = P; goto connecting_respond; /* 2 */
}

mode connecting_request x<= 0 { 
	when respond_pid < P may parent = respond_pid; respond_pid = NULL; goto idle; /* 3 */
	when respond_pid > P may respond_pid = NULL; goto idle; /* 4 */
}

mode connecting_respond x<= 0 { 
	when request_pid < P may parent = request_pid; request_pid = NULL; goto idle; /* 5 */
	when request_pid > P may request_pid = NULL; goto idle; /* 6 */
} 

initially 
    time == 0 && request_pid == NULL && respond_pid == NULL && forall i, (idle[i] && x[i] == 0 && parent[i] == NULL); 
 

risk 
    time > DEADLINE*PERIOD && respond_pid == NULL && request_pid == NULL 
&&  exists i, exists j: i<j, (parent[i] == NULL && parent[j] == NULL) 
&&  forall i, idle[i]; 


