#define FALSE 0
#define TRUE 1
#define SUSPEND 2
#define LB 26
#define UB 52

process count = 5;
global discrete sender_Con: 0...2;
global discrete receiver_Con: 0...2;
global discrete sender_Buffer: 0...2;
global discrete receiver_Buffer: 0...2;
local clock x, RTX, ERTX;
global synchronizer
L2CA_ConnectReqs,L2CA_ConnectInds,L2CA_ConnectRsps,L2CA_ConnectRspNegs,
L2CA_ConfigInds,L2CA_ConfigRsps,L2CA_ConfigRspNegs,L2CA_ConfigCfmNegs,
L2CA_ConnectCfms,L2CA_ConnectPnds,L2CA_ConnectCfmNegs,L2CA_ConfigReqs,
L2CA_DisconnectInds,L2CA_ConfigCfms,L2CA_Reads,L2CA_DisconnectRsps,
L2CA_DisconnectReqs,L2CA_DataReads,L2CA_DataWrites,L2CA_DisconnectCfms,
L2CA_ConnectReqr,L2CA_ConnectIndr,L2CA_ConnectRspr,L2CA_ConnectRspNegr,
L2CA_ConfigIndr,L2CA_ConfigRspr,L2CA_ConfigRspNegr,L2CA_ConfigCfmNegr,L2CA_ConnectCfmr,
L2CA_ConnectPndr,L2CA_ConnectCfmNegr,L2CA_ConfigReqr,L2CA_DisconnectIndr,L2CA_ConfigCfmr,
L2CA_Readr,L2CA_DisconnectRspr,L2CA_DisconnectReqr,L2CA_DataReadr,L2CA_DataWriter,
L2CA_DisconnectCfmr,
creq_s2n, creq_n2r,creq_r2n, creq_n2s,crsp_r2n,crsp_n2s,crspneg_r2n ,crspneg_n2s ,
crspneg_s2n ,crspneg_n2r ,crspd_s2n, crspd_n2s,
req_config_s2n,req_config_n2r,req_config_r2n,req_config_n2s,rsp_config_s2n,
rsp_config_n2r,rsp_config_r2n,rsp_config_n2s,
rspneg_config_s2n,rspneg_config_n2r,rspneg_config_r2n,rspneg_config_n2s,
discreq_s2n, discreq_n2r,discrsp_r2n,discrsp_n2s,discrspneg_r2n ,discrspneg_n2s ,
discreq_r2n, discreq_n2s,discrsp_s2n,discrsp_n2r,discrspneg_s2n ,discrspneg_n2r ,
reject_r2n,reject_n2s,reject_s2n,reject_n2r,data_r2n,data_n2s,data_s2n,data_n2r,
crspd_r2n,crsp_s2n,reqneg_config_s2n,crsp_n2r,crspd_n2r ;


mode  UPPERL2CAPs_idle true {
  when !L2CA_ConnectReqs sender_Con==0 may ;
  when ?L2CA_ConnectInds  true may x=0; goto UPPERL2CAPs_ConnectRsp;
  when ?L2CA_ConfigInds  true may x=0; goto UPPERL2CAPs_ConfigRsp;
  when ?L2CA_ConnectCfms  true may x=0; goto UPPERL2CAPs_ConfigOpen;
  when ?L2CA_ConnectCfmNegs true may;
  when ?L2CA_ConfigCfms sender_Con==0 may x=0;
  when ?L2CA_ConfigCfms sender_Con==1 may x=0; goto UPPERL2CAPs_DataWrite;
  when ?L2CA_ConfigCfmNegs true may;
  when ?L2CA_DataReads true may x=0; goto UPPERL2CAPs_Data;
  when ?L2CA_DisconnectInds true may x=0; goto UPPERL2CAPs_DisconnectRsp;
  when ?L2CA_DisconnectCfms true may;
}

mode UPPERL2CAPs_ConnectRsp x<=UB {
  when !L2CA_ConnectRsps sender_Buffer == 0 may goto UPPERL2CAPs_idle;
  when !L2CA_ConnectRspNegs sender_Buffer == 1 may goto UPPERL2CAPs_idle;
}
mode UPPERL2CAPs_ConfigRsp x<=UB {
  when !L2CA_ConfigRsps sender_Buffer ==0 may goto UPPERL2CAPs_ConfigOpen;
  when !L2CA_ConfigRspNegs sender_Buffer ==1 may goto UPPERL2CAPs_idle;
}
mode UPPERL2CAPs_ConfigOpen x<=UB {
  when !L2CA_ConfigReqs x>=LB may x=0; goto UPPERL2CAPs_idle;
  when sender_Con==1 and x>=LB may x=0; goto UPPERL2CAPs_idle;
}
mode UPPERL2CAPs_Data x<=UB {
  when sender_Buffer==0 may goto UPPERL2CAPs_idle;
  when !L2CA_DisconnectReqs sender_Buffer==1 may goto UPPERL2CAPs_idle;
}
mode UPPERL2CAPs_DisconnectRsp x<=UB {
  when !L2CA_DisconnectRsps x>=LB may x=0; goto UPPERL2CAPs_idle;
}
mode UPPERL2CAPs_DataWrite x<=UB {
  when !L2CA_DataWrites x>=LB may x=0; goto UPPERL2CAPs_idle;
}


mode CLOSEDs true {
  when ?creq_n2s !L2CA_ConnectInds true may goto W4_L2CA_CONNECT_RSPs;
  when ?req_config_n2s !reject_s2n true may ;
  when ?L2CA_ConnectReqs !creq_s2n true may  RTX=0; goto W4_L2CAP_CONNECT_RSPs;
  when ?L2CA_ConfigReqs !L2CA_ConfigCfmNegs true may ;
  when ?discreq_n2s !discrsp_s2n true may ;
}

mode W4_L2CAP_CONNECT_RSPs RTX<60 {
  when ?crsp_n2s !L2CA_ConnectCfms true may /* RTX:=DISABLED */; goto CONFIGs;
  when ?crspd_n2s !L2CA_ConnectPnds true may  /* RTX:=DISABLED; ERTX:=0; */goto W4_L2CAP_CONNECT_RSPs;
  when ?crspneg_n2s !L2CA_ConnectCfmNegs true may /* RTX:=DISABLED; ERTX:=DISABLED; */goto CLOSEDs;
  when ?discreq_n2s !L2CA_DisconnectInds true may goto W4_L2CA_DISCONNECT_RSPs;
}

mode W4_L2CA_CONNECT_RSPs true {
  when ?discreq_n2s !L2CA_DisconnectInds true may goto W4_L2CA_DISCONNECT_RSPs;
  when ?L2CA_ConnectRsps !crsp_s2n true may goto CONFIGs;
  when ?L2CA_ConnectRspNegs !crspneg_s2n true may goto CLOSEDs;
}

mode CONFIGs true {
  when ?req_config_n2s !L2CA_ConfigInds true may goto CONFIGs;
  when ?rsp_config_n2s !L2CA_ConfigCfms sender_Con==0 may ; /* RTX:=DISABLED ;*/ goto CONFIGs;
  when ?rsp_config_n2s !L2CA_ConfigCfms sender_Con==1 may ; /* RTX:=DISABLED ;*/goto OPENs;
  when ?rspneg_config_n2s !L2CA_ConfigCfmNegs true may /* RTX:=DISABLED;*/ goto CONFIGs;
  when ?discreq_n2s !L2CA_DisconnectInds true may goto W4_L2CA_DISCONNECT_RSPs;
  when ?L2CA_ConfigReqs !req_config_s2n true may RTX=0; goto CONFIGs;
  when ?L2CA_ConfigRsps !rsp_config_s2n sender_Con == 0 may sender_Con=1; goto CONFIGs;
  when ?L2CA_ConfigRsps !rsp_config_s2n sender_Con == 1 may goto OPENs;
  when ?L2CA_ConfigRspNegs !rspneg_config_s2n true may goto CONFIGs;
  when ?L2CA_DisconnectReqs !discreq_s2n true may RTX=0; goto W4_L2CAP_DISCONNECT_RSPs;
}

mode OPENs true {
  when ?req_config_n2s !L2CA_ConfigInds true may sender_Buffer= 2; goto CONFIGs;
  when ?discreq_n2s !L2CA_DisconnectInds true may goto W4_L2CA_DISCONNECT_RSPs;
  when ?data_n2s !L2CA_DataReads true may x=0; sender_Buffer=1; goto OPENs;
  when ?L2CA_ConfigReqs !reqneg_config_s2n true may RTX=0; sender_Buffer= 2; goto CONFIGs;
  when ?L2CA_DisconnectReqs !discreq_s2n true may RTX=0; goto W4_L2CAP_DISCONNECT_RSPs;
  when ?L2CA_DataReads true may sender_Buffer= 1; goto OPENs;
  when ?L2CA_DataWrites !data_s2n true may goto OPENs;
}

mode W4_L2CA_DISCONNECT_RSPs true {
  when ?discreq_n2s !L2CA_DisconnectInds true may goto W4_L2CA_DISCONNECT_RSPs;
  when ?L2CA_DisconnectRsps !discrsp_s2n true may goto CLOSEDs;
}

mode W4_L2CAP_DISCONNECT_RSPs true {
  when ?discreq_n2s !L2CA_DisconnectInds true may goto W4_L2CA_DISCONNECT_RSPs;
  when ?discrsp_n2s!L2CA_DisconnectCfms true may /* RTX:=DISABLED;*/ goto CLOSEDs;
}

mode  UPPERL2CAPr_idle true {
  when !L2CA_ConnectReqr receiver_Con==0 may ;
  when ?L2CA_ConnectIndr  true may x=0; goto UPPERL2CAPr_ConnectRsp;
  when ?L2CA_ConfigIndr  true may x=0; goto UPPERL2CAPr_ConfigRsp;
  when ?L2CA_ConnectCfmr  true may x=0; goto UPPERL2CAPr_ConfigOpen;
  when ?L2CA_ConnectCfmNegr true may;
  when ?L2CA_ConfigCfmr receiver_Con==0 may x=0;
  when ?L2CA_ConfigCfmr receiver_Con==1 may x=0; goto UPPERL2CAPr_DataWrite;
  when ?L2CA_ConfigCfmNegr true may;
  when ?L2CA_DataReadr true may goto UPPERL2CAPr_Data;
  when ?L2CA_DisconnectIndr true may x=0; goto UPPERL2CAPr_DisconnectRsp;
  when ?L2CA_DisconnectCfmr true may;
}

mode UPPERL2CAPr_ConnectRsp x<=UB {
  when !L2CA_ConnectRspr receiver_Buffer == 0 may goto UPPERL2CAPr_idle;
  when !L2CA_ConnectRspNegr receiver_Buffer == 1 may goto UPPERL2CAPr_idle;
}
mode UPPERL2CAPr_ConfigRsp x<=UB {
  when !L2CA_ConfigRspr receiver_Buffer ==0 may goto UPPERL2CAPr_ConfigOpen;
  when !L2CA_ConfigRspNegr receiver_Buffer ==1 may goto UPPERL2CAPr_idle;
}
mode UPPERL2CAPr_ConfigOpen x<=UB {
  when !L2CA_ConfigReqr x>=LB may x=0; goto UPPERL2CAPr_idle;
  when receiver_Con==1 and x>=LB may x=0; goto UPPERL2CAPr_idle;
}
mode UPPERL2CAPr_Data x<=UB {
  when receiver_Buffer==0 may goto UPPERL2CAPr_idle;
  when !L2CA_DisconnectReqr receiver_Buffer==1 may goto UPPERL2CAPr_idle;
}
mode UPPERL2CAPr_DisconnectRsp x<=UB {
  when !L2CA_DisconnectRspr x>=LB may x=0; goto UPPERL2CAPr_idle;
}
mode UPPERL2CAPr_DataWrite x<=UB {
  when !L2CA_DataWriter x>=LB may x=0; goto UPPERL2CAPr_idle;
}

mode CLOSEDr true {

  when ?creq_n2r !L2CA_ConnectIndr true may goto W4_L2CA_CONNECT_RSPr;
  when ?req_config_n2r !reject_r2n true may goto CLOSEDr;
  when ?L2CA_ConnectReqr !creq_r2n true may  RTX=0; goto W4_L2CAP_CONNECT_RSPr;
  when ?L2CA_ConfigReqr !L2CA_ConfigCfmNegr true may  goto CLOSEDr;
  when ?discreq_n2r !discrsp_r2n true may  goto CLOSEDr;
}                       

mode W4_L2CAP_CONNECT_RSPr RTX<60 {
  when ?crsp_n2r !L2CA_ConnectCfmr true may /* RTX:=DISABLED */; goto CONFIGr;
  when ?crspd_n2r !L2CA_ConnectPndr true may  /* RTX:=DISABLED; ERTX:=0; */goto W4_L2CAP_CONNECT_RSPr;
  when ?crspneg_n2r !L2CA_ConnectCfmNegr true may /* RTX:=DISABLED; ERTX:=DISABLED; */goto CLOSEDr;
  when ?discreq_n2r !L2CA_DisconnectIndr true may goto W4_L2CA_DISCONNECT_RSPr;
}

mode W4_L2CA_CONNECT_RSPr true {
  when ?discreq_n2r !L2CA_DisconnectIndr true may goto W4_L2CA_DISCONNECT_RSPr;
  when ?L2CA_ConnectRspr !crsp_r2n true may goto CONFIGr;
  when ?L2CA_ConnectRspNegr !crspneg_r2n true may goto CLOSEDr;
}

mode CONFIGr true {
  when ?req_config_n2r !L2CA_ConfigIndr true may goto CONFIGr;
  when ?rsp_config_n2r !L2CA_ConfigCfmr receiver_Con==0 may /* RTX:=DISABLED ;*/ goto CONFIGr;
  when ?rsp_config_n2r !L2CA_ConfigCfmr receiver_Con==1 may /* RTX:=DISABLED ;*/goto OPENr;
  when ?rspneg_config_n2r !L2CA_ConfigCfmNegr true may /* RTX:=DISABLED;*/ goto CONFIGr;
  when ?discreq_n2r !L2CA_DisconnectIndr true may goto W4_L2CA_DISCONNECT_RSPr;
  when ?L2CA_ConfigReqr !req_config_r2n true may RTX=0; goto CONFIGr;
  when ?L2CA_ConfigRspr !rsp_config_r2n receiver_Con == 0 may receiver_Con=1; goto CONFIGr;
  when ?L2CA_ConfigRspr !rsp_config_r2n receiver_Con == 1 may goto OPENr;
  when ?L2CA_ConfigRspNegr !rspneg_config_r2n true may goto CONFIGr;
  when ?L2CA_DisconnectReqr !discreq_r2n true may RTX=0; goto W4_L2CAP_DISCONNECT_RSPr;
}

mode OPENr true {
  when ?req_config_n2r !L2CA_ConfigIndr true may receiver_Buffer= 2; goto CONFIGr;
  when ?discreq_n2r !L2CA_DisconnectIndr true may goto W4_L2CA_DISCONNECT_RSPr;
  when ?data_n2r !L2CA_DataReadr true may x=0; receiver_Buffer=1; goto OPENr;
  when ?L2CA_ConfigReqr !req_config_r2n true may RTX=0; receiver_Buffer= 2; goto CONFIGr;
  when ?L2CA_DisconnectReqr !discreq_r2n true may RTX=0; goto W4_L2CAP_DISCONNECT_RSPr;
  when ?L2CA_DataReadr true may receiver_Buffer= 1; goto OPENr;
  when ?L2CA_DataWriter !data_r2n true may goto OPENr;
}

mode W4_L2CA_DISCONNECT_RSPr true {
  when ?discreq_n2r !L2CA_DisconnectIndr true may goto W4_L2CA_DISCONNECT_RSPr;
  when ?L2CA_DisconnectRspr !discrsp_r2n true may goto CLOSEDr;
}

mode W4_L2CAP_DISCONNECT_RSPr true {
  when ?discreq_n2r !L2CA_DisconnectIndr true may goto W4_L2CA_DISCONNECT_RSPr;
  when ?discrsp_n2r !L2CA_DisconnectCfmr true may /* RTX:=DISABLED;*/ goto CLOSEDr;
}

mode net_idle true {
  /* for each event, the following two lines should be incorporated. */
  when ?creq_s2n true may x= 0; goto net_creq_from_sender;
  when ?creq_s2n true may ;  /* the message is lost. */
  when ?crsp_r2n true may x=0; goto net_crsp_from_receiver;
  when ?crsp_r2n true may ;
  when ?crspneg_r2n true may x=0; goto net_crspneg_from_receiver;
  when ?crspneg_r2n true may ;
  when ?creq_r2n true may x= 0; goto net_creq_from_receiver;
  when ?creq_r2n true may ;  /* the message is lost. */
  when ?crsp_s2n true may x=0; goto net_crsp_from_sender;
  when ?crsp_s2n true may ;
  when ?crspd_s2n true may x=0; goto net_crspd_from_sender;
  when ?crspd_s2n true may ;
  when ?crspd_r2n true may x=0; goto net_crspd_from_receiver;
  when ?crspd_r2n true may ;
  when ?crspneg_s2n true may x=0; goto net_crspneg_from_sender;
  when ?crspneg_s2n true may ;
  when ?discreq_s2n true may x= 0; goto net_discreq_from_sender;
  when ?discreq_s2n true may ;  /* the message is lost. */
  when ?discrsp_r2n true may x=0; goto net_discrsp_from_receiver;
  when ?discrsp_r2n true may ;
  when ?discrspneg_r2n true may x=0; goto net_discrsp_from_receiver;
  when ?discrspneg_r2n true may ;
  when ?discreq_r2n true may x= 0; goto net_discreq_from_receiver;
  when ?discreq_r2n true may ;  /* the message is lost. */
  when ?discrsp_s2n true may x=0; goto net_discrsp_from_sender;
  when ?discrsp_s2n true may ;
  when ?discrspneg_s2n true may x=0; goto net_discrsp_from_sender;
  when ?discrspneg_s2n true may ;
  when ?req_config_s2n true may x=0;goto net_req_config_from_sender;
  when ?req_config_s2n true may ;
  when ?req_config_r2n true may x=0;goto net_req_config_from_receiver;
  when ?req_config_r2n true may ;
  when ?rsp_config_r2n true may x=0;goto net_rsp_config_from_receiver;
  when ?rsp_config_r2n true may ;
  when ?rsp_config_s2n true may x=0;goto net_rsp_config_from_sender;
  when ?rsp_config_s2n true may ;
  when ?rspneg_config_r2n true may x=0;goto net_rspneg_config_from_receiver;
  when ?rspneg_config_r2n true may ;
  when ?rspneg_config_s2n true may x=0;goto net_rspneg_config_from_sender;
  when ?rspneg_config_s2n true may ;
  when ?reject_s2n true may x=0;goto net_reject_from_sender;
  when ?reject_s2n true may ;
  when ?reject_r2n true may x=0;goto net_reject_from_receiver;
  when ?reject_r2n true may ;
  when ?data_s2n true may x=0;goto net_data_from_sender;
  when ?data_s2n true may ;
  when ?data_r2n true may x=0;goto net_data_from_receiver;
  when ?data_r2n true may ;

}

mode net_creq_from_sender x<=UB {
  when !creq_n2r x>=LB may x=0; goto net_idle;
}

mode net_crsp_from_receiver x<=UB {
  when !crsp_n2s x>=LB may x=0; goto net_idle;
}

mode net_crspd_from_receiver x<=UB {
  when !crspd_n2s x>=LB may x=0; goto net_idle;
}

mode net_crspneg_from_receiver x<=UB {
  when !crspneg_n2s x>=LB may x=0; goto net_idle;
}

mode net_creq_from_receiver x<=UB {
  when !creq_n2s x>=LB may x=0; goto net_idle;
}

mode net_crsp_from_sender x<=UB {
  when !crsp_n2r x>=LB may x=0; goto net_idle;
}

mode net_crspd_from_sender x<=UB {
  when !crspd_n2r x>=LB may x=0; goto net_idle;
}

mode net_crspneg_from_sender x<=UB {
  when !crspneg_n2r x>=LB may x=0; goto net_idle;
}

mode net_discreq_from_sender x <=UB {
  when !discreq_n2r x>=LB may x=0; goto net_idle;
}

mode net_discreq_from_receiver x<=UB {
  when !discreq_n2s x>= LB may x=0; goto net_idle;
}

mode net_discrsp_from_receiver x<=UB {
  when !discrsp_n2s x>=LB may x=0; goto net_idle;
}

mode net_discrsp_from_sender x<=UB {
  when !discrsp_n2r x>=LB may x=0; goto net_idle;
}


mode net_req_config_from_sender x<=UB {
 when !req_config_n2r x>=LB may x=0; goto net_idle;
}

mode net_req_config_from_receiver x<=UB {
 when !req_config_n2s x>=LB may x=0; goto net_idle;
}

mode net_rsp_config_from_sender x<=UB {
 when !rsp_config_n2r x>=LB may x=0; goto net_idle;
}

mode net_rsp_config_from_receiver x<=UB {
 when !rsp_config_n2s x>=LB may x=0; goto net_idle;
}

mode net_rspneg_config_from_sender x<=UB {
 when !rspneg_config_n2r x>=LB may x=0; goto net_idle;
}

mode net_rspneg_config_from_receiver x<=UB {
 when !rspneg_config_n2s x>=LB may x=0; goto net_idle;
}

mode net_reject_from_sender x<=UB {
  when !reject_n2r x>=LB may x=0; goto net_idle;
}

mode net_reject_from_receiver x<=UB {
  when !reject_n2s x>=LB may x=0; goto net_idle;
}

mode net_data_from_sender x<=UB {
  when !data_n2r x>=LB may x=0; goto net_idle;
}

mode net_data_from_receiver x<=UB {
  when !data_n2s x>=LB may x=0; goto net_idle;
}


initially
UPPERL2CAPs_idle[1] and x[1]==0
and UPPERL2CAPr_idle[2] and x[2]==0
and CLOSEDs[3] and RTX[3] == 0 and ERTX[3] ==0 and sender_Buffer== 0 and sender_Con==0
and CLOSEDr[4] and RTX[4] == 0 and ERTX[4] ==0 and receiver_Buffer== 0 and receiver_Con==0
and net_idle[5] and x[5]==0 ;

risk
not (OPENs[3] and OPENr[4]);











