process count = 4; /* 1 is for bus, the others for senders. */

#define	LAMBDA	808
parameter
	A, /* 26 */
	B; /* 52 */
/*	LAMBDA;  808 */

local clock x;
global synchronizer begin, end, cd, busy;

mode bus_idle true {
	when ?begin true  may x= 0; goto bus_active; /* 1 */
}

mode bus_active true {
	when ?end true  may x= 0; goto bus_idle; /* 2 */
	when !busy x >= A may ; /* 3 */
	when ?begin x < A  may x= 0; goto bus_collision; /* 4 */
}

mode bus_collision x < A {
	when !cd !cd !cd x < A  may x= 0; goto bus_idle; /* 5 */
}


mode sender_wait true {
	when !begin true may x= 0; goto sender_transm; /* 6 */
	when ?cd true may x= 0; /* 7 */
	when ?cd true may x= 0; goto sender_retry; /* 8 */
	when ?busy true may x= 0; goto sender_retry; /* 9 */
}

mode sender_transm x <= LAMBDA {
	when !end x==LAMBDA may x= 0; goto sender_wait; /* 10 */
	when ?cd x<B may x= 0; goto sender_retry; /* 11 */
}

mode sender_retry x < B {
	when !begin x < B may x= 0; goto sender_transm; /* 12 */
	when ?busy true may x= 0; /* 13 */
	when ?cd x < B may x= 0; /* 14 */
}



initially
    B>=52 && bus_idle[1] and x[1] == 0 and forall i:i>1, (sender_wait[i] and x[i] == 0);


parametric risk
    exists i: i> 1, exists j: j> i,
    (sender_transm[i] and sender_transm[j] and (x[i] >= B or x[j] >= B))
;

debug
/*
 (0)V=48:mode[4];835b6d0;1080;IC=1;[sender_retry]81990b0;
   (1)V=52:(-x[4]);81990b0;1080;IC=1;<=0:8181850;
     (2)V=52:(x[4]);8181850;1080;IC=1;<404:8318b50;
       (3)V=52:(-2A+x[4]);8318b50;1080;IC=1;<-404/3::817f248;
         (4)V=52:(-7A+x[4]);817f248;1080;IC=1;<-808:819fec0;
           (5)V=52:(-A-3B+x[4]);819fec0;1080;IC=1;<-808:81aee98;
             (6)V=52:(A-B+x[4]);81aee98;1080;IC=1;<0:TRUE;
*/
    sender_retry[4]
&&

x
[
4
]
>=
0
&&  x[4]<404
&&
-2
*
A
+
x
[
4
]
<
-404/3
&&  -7*A+x[4]<-808
&&  -1*A-3*B+x[4]<-808
&&  A-B+x[4]<0;

    sender_retry[4]
&&  x[4]>=0
&&  x[4]<404
&& A-B+x[4]<0
&&  (	(   -2*A+x[4]<-404/3
         && -7*A+x[4]<-808
         && -1*A-3*B+x[4]<-808
         && A-B+x[4]<0
	 )
     || (   -2*A+x[4]<-808/7
         && -4*B+x[4]<-808
	 )
     || -5*B+x[4]<-808
     || -6*B+x[4]<-808
     || -7*B+x[4]<-808
     || -8*B+x[4]<-808
     );

