process count = 3;

parameter
	T;
local  clock
	x;
global synchronizer
 	add_1, remove_1,
	add_2, remove_2;

/* ROD 1 */
/*0*/
mode out_1 true {
    when ?add_1 x >= T may goto in_1;
}

mode in_1 true {
    when ?remove_1 true  may x = 0; goto out_1;
}
/* ENd of ROD 1 */

/* ROD 2 */
mode out_2 true {
    when ?add_2 x >= T may goto in_2;
}

mode in_2 true {
    when ?remove_2 true may x = 0; goto out_2;
}
/* ENd of ROD 2 */



/* Here x emulates the temperature. */
mode no_rod x <= 161/10 {
    when !add_1 16 <= x && x <= 161/10 may x = 0; goto rod_1;
    when !add_2 16 <= x && x <= 161/10 may x = 0; goto rod_2;
}

mode rod_1 x <= 161/10 {
    when !remove_1 16 <= x && x <= 161/10 may x = 0; goto no_rod;
}

mode rod_2 x <= 59/10 {
    when !remove_2 58/10 <= x && x <= 59/10 may x = 0; goto no_rod;
}


initially
	out_1[1] and out_2[2] and no_rod[3] and
 	x[1] == T and x[2] == T and x[3] == 0;

parametric risk
	   no_rod[3] && 16 <= x[3] && x[3] <= 161/10
	&& out_1[1] && x[1] <= T
	&& out_2[2] && x[2] <= T;
