process count = 8;

parameter
	T;
local  clock
	x;
global synchronizer
 	add_1, remove_1,
	add_2, remove_2,
	add_3, remove_3,
	add_4, remove_4,
	add_5, remove_5,
	add_6, remove_6,
	add_7, remove_7;

/* ROD 1 */
mode out_1 true {
    when ?add_1 x >= T may goto in_1;
}

mode in_1 true {
    when ?remove_1 true  may x = 0; goto out_1;
}
/* ENd of ROD 1 */

/* ROD 2 */
mode out_2 true {
    when ?add_2 x >= T may goto in_2;
}

mode in_2 true {
    when ?remove_2 true may x = 0; goto out_2;
}
/* ENd of ROD 2 */

/* ROD 3 */
mode out_3 true {
    when ?add_3 x >= T may goto in_3;
}

mode in_3 true {
    when ?remove_3 true  may x = 0; goto out_3;
}
/* ENd of ROD 3 */


/* ROD 4 */
mode out_4 true {
    when ?add_4 x >= T may goto in_4;
}

mode in_4 true {
    when ?remove_4 true  may x = 0; goto out_4;
}
/* ENd of ROD 4 */


/* ROD 5 */
mode out_5 true {
    when ?add_5 x >= T may goto in_5;
}

mode in_5 true {
    when ?remove_5 true  may x = 0; goto out_5;
}
/* ENd of ROD 5 */


/* ROD 6 */
mode out_6 true {
    when ?add_6 x >= T may goto in_6;
}

mode in_6 true {
    when ?remove_6 true  may x = 0; goto out_6;
}
/* ENd of ROD 6 */


/* ROD 7 */
mode out_7 true {
    when ?add_7 x >= T may goto in_7;
}

mode in_7 true {
    when ?remove_7 true  may x = 0; goto out_7;
}
/* ENd of ROD 7 */


/* Here x emulates the temperature. */
mode no_rod x <= 161/10 {
    when !add_1 16 <= x && x <= 161/10 may x = 0; goto rod_1;
    when !add_2 16 <= x && x <= 161/10 may x = 0; goto rod_2;
    when !add_3 16 <= x && x <= 161/10 may x = 0; goto rod_3;
    when !add_4 16 <= x && x <= 161/10 may x = 0; goto rod_4;
    when !add_5 16 <= x && x <= 161/10 may x = 0; goto rod_5;
    when !add_6 16 <= x && x <= 161/10 may x = 0; goto rod_6;
    when !add_7 16 <= x && x <= 161/10 may x = 0; goto rod_7;
}

mode rod_1 x <= 161/10 {
    when !remove_1 16 <= x && x <= 161/10 may x = 0; goto no_rod;
}

mode rod_2 x <= 59/10 {
    when !remove_2 58/10 <= x && x <= 59/10 may x = 0; goto no_rod;
}

mode rod_3 x <= 59/10 {
    when !remove_3 58/10 <= x && x <= 59/10 may x = 0; goto no_rod;
}

mode rod_4 x <= 59/10 {
    when !remove_4 58/10 <= x && x <= 59/10 may x = 0; goto no_rod;
}

mode rod_5 x <= 59/10 {
    when !remove_5 58/10 <= x && x <= 59/10 may x = 0; goto no_rod;
}

mode rod_6 x <= 59/10 {
    when !remove_6 58/10 <= x && x <= 59/10 may x = 0; goto no_rod;
}

mode rod_7 x <= 59/10 {
    when !remove_7 58/10 <= x && x <= 59/10 may x = 0; goto no_rod;
}


initially
	out_1[1] and x[1] == T
and 	out_2[2] and x[2] == T
and 	out_3[3] and x[3] == T
and 	out_4[4] and x[4] == T
and 	out_5[5] and x[5] == T
and 	out_6[6] and x[6] == T
and 	out_7[7] and x[7] == T
and 	no_rod[8] and x[8] == 0;

parametric risk
	   no_rod[8] && 16 <= x[8] && x[8] <= 161/10
	&& out_1[1] && x[1] <= T
	&& out_2[2] && x[2] <= T
	&& out_3[3] && x[3] <= T
	&& out_4[4] && x[4] <= T
	&& out_5[5] && x[5] <= T
	&& out_6[6] && x[6] <= T
	&& out_7[7] && x[7] <= T;
