
%{
#define	COMMENT		1
#define	ASTER_FOUND	2
#define POSSIBLY_DEEPER	3
#define FOREVER		1

static char	*lex_test; 

static int	depth_comment = 0; 

%}
nl	\n
%%

"#define" 	{
		  if (depth_comment) {
       		  /* 
                    fprintf(out, "\nllex: Commented macro definition.\n"); 
                    fflush(out); 
                  */
		  }
		  else if (flag_line_start == 1) { 
/*
		    fprintf(out, "Macro definition of constant\n");
*/
		    flag_line_start = 2; 
	    	  }
		  else {
		    fprintf(out, "Error at line %1d: macro definition not at the beginning of a line.\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  }
		}

"/*"		{ /* fprintf(out, "\nllex: incrementing comment depth from %1d: %s\n", depth_comment, yytext); 
		  fflush(out); 
                  */
		  depth_comment++; 
		  flag_line_start = FALSE; 
		}

"*/"		{ 
		  if (depth_comment > 0) {
       		  /* 
                    fprintf(out, 
			    "\nllex: decrementing comment depth from %1d: %s\n", depth_comment, yytext); 
	  	    fflush(out); 
                  */
	 	    depth_comment--; 
          	  } 
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
       		  else {
         	    fprintf(out, "\nllex: an unexpected comment end when depth_comment = %1d: %s\n", 
				 depth_comment, yytext
				 ); 
                    fflush(out); 
                  }
	        }

"!"		{
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented exclamation: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "\nllex: Exclamation: %s\n", yytext); 
                    fflush(out); 
                  */
                    return(PS_EXCLAMATION);
                  }
                }

"?"		{ 
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented question: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  }
                  else {
       		  /* 
                    fprintf(out, "\nllex: Question: %s\n", yytext); 
                    fflush(out); 
                  */
                    return(PS_QUESTION);
                  }
                }

";"		{ 
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented semicolon: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "\nllex: Semicolon: %s\n", yytext); 
                    fflush(out); 
                  */
                    return(PS_SEMICOLON);
                  }
                }

"->"		{ 
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented RIGHTARROW: %s\n", yytext);
                    fflush(out); 
*/
                  } 
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "lex RIGHTARROW : %s\n", yytext); 
                  */
		    return(PS_RIGHTARROW);
                  }
		}

"=="		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented EQ: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex EQ : %s\n", yytext); 
                  */
		    return(PS_EQ);
                  }
		}

"!="		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented NEQ: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex NEQ : %s\n", yytext); 
                  */
		    return(PS_NEQ);
                  }
		}

"="		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented ASSIGNMENT: %s\n", yytext);
                    fflush(out); 
*/
                  } 
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "lex ASSIGNMENT : %s\n", yytext); 
                  */
		    return(PS_ASSIGNMENT);
                  }
		}
":="		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented ASSIGNMENT: %s\n", yytext);
                    fflush(out); 
*/
                  } 
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  
                    fprintf(out, "Message: lex ASSIGNMENT operator ':=' has been changed to '=' at line %1d\n", 
                    	    lineno
                    	    ); 
		    fprintf(out, "         to comply with C/C++ syntax.\n");                   
		    exit(0);
                  }
		}
":"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: Commented colon: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "\nllex: Colon: %s\n", yytext); 
                  */
                    return(PS_COLON);
                  }
                }

"local"         { 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented local: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out);
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "\nllex local : %s\n", yytext); 
                  */
		    return(PS_LOCAL); 
                  }
		} 

"global"        { 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented global: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "\nllex: global: %s\n", yytext); 
                  */
		    return(PS_GLOBAL); 
                  }
		} 

"parameter" {
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented parameter: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
       		  /*
                    fprintf(out, "\nllex: parameter: %s\n", yytext);
                  */
 		    return(PS_PARAMETER);
                  }
		}

"clock"         {
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented clock: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
       		  /*
                    fprintf(out, "\nllex: clock: %s\n", yytext);
                  */
 		    return(PS_CLOCK);
                  }
		}

"dense"         {
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented dense: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
       		  /*
                    fprintf(out, "\nllex: dense: %s\n", yytext);
                  */
 		    return(PS_DENSE);
                  }
		}

"discrete"      {
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented discrete: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "\nllex: discrete: %s\n", yytext); 
                  */
		    return(PS_DISCRETE); 
                  }
		} 
"monitor"      { 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented discrete: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "\nllex: discrete: %s\n", yytext); 
                  */
		    return(PS_MONITOR); 
                  }
		}

"pointer"       { 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented pointer: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "\nllex: pointer: %s\n", yytext); 
                  */
		    return(PS_POINTER); 
                  }
		} 

"synchronizer"  { 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented pointer: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0);
		  } 
                  else {
       		  /* 
                    fprintf(out, "\nllex: pointer: %s\n", yytext); 
                  */
		    return(PS_SYNCHRONIZER); 
                  }
		} 

"not"           { 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented NOT: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "lex NOT : %s\n", yytext); 
                  */
		    return(PS_NOT);
                  }
		}

"urgent" 	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented mode: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "lex urgent : %s\n", yytext); 
                  */
		    return(PS_URGENT);
                  }
		}

"mode" 		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented mode: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "lex mode : %s\n", yytext);
                  */
		    return(PS_MODE);
                  }
		}

"process" 	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented process: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "lex process : %s\n", yytext); 
                  */
		    return(PS_PROCESS);
                  }
		}

"rate" 		{
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented rate: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
       		  /*
                    fprintf(out, "lex : %s\n", yytext);
                  */
		    return(PS_RATE);
                  }
		}

"when" 		{
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented when: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
       		  /*
                    fprintf(out, "lex : %s\n", yytext);
                  */
		    return(PS_WHEN);
                  }
		}

"may" 		{
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented may: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext); 
                  */
		    return(PS_MAY);
                  }
		}

"in" 		{
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented in: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext);
                  */
		    return(PS_IN);
                  }
		}
"goto" 		{
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented goto: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext);
                  */
		    return(PS_GOTO);
                  }
		}

"oo" 		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented risk: %s\n", yytext);
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext); 
                  */
		    return(PS_INFINITY);
                  }
		}

"risk" 		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented risk: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext); 
                  */
		    return(PS_RISK);
                  }
		}

"goal" 		{
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented goal: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext);
                  */
		    return(PS_GOAL);
                  }
		}

"safety" 		{
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented safety: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext);
                  */
		    return(PS_SAFETY);
                  }
		}

"parametric" {
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented parametric: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
       		  /*
                    fprintf(out, "\nllex: parametric: %s\n", yytext);
                  */
 		    return(PS_PARAMETRIC);
                  }
		}

"specification" 	{
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented specification: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext);
                  */
		    return(PS_SPECIFICATION);
                  }
		}
"debug" 	{
		  if (depth_comment) {
/*
                    fprintf(out, "\nllex: commented debug: %s\n", yytext);
                    fflush(out);
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno);
		    fflush(out);
		    exit(0);
		  }
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext);
                  */
		    return(PS_DEBUG);
                  }
		}
"tctl" 	{
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented specification: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext); 
                  */
		    return(PS_SPECIFICATION);
                  }
		}
"deadlock" 	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented specification: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext); 
                  */
		    return(PS_DEADLOCK);
                  }
		}
"zeno" 	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented specification: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext); 
                  */
		    return(PS_ZENO);
                  }
		}

"initially" 	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented initial: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /* 
                    fprintf(out, "lex : %s\n", yytext); 
                  */
		    return(PS_INITIAL);
                  }
		}

"and"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented and: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex AND : %s\n", yytext); 
                  */
		    return(PS_AND);
                  }
		}
"&&"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented and: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex AND : %s\n", yytext); 
                  */
		    return(PS_AND);
                  }
		}
"or"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented or: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex OR : %s\n", yytext); 
                  */
		    return(PS_OR);
                  }
		}
"||"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented or: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex OR : %s\n", yytext); 
                  */
		    return(PS_OR);
                  }
		}
"until"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented until: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex UNTIL : %s\n", yytext); 
                  */
		    return(PS_UNTIL);
                  }
		}
"always"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented always: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex ALWAYS : %s\n", yytext); 
                  */
		    return(PS_ALWAYS);
                  }
		}
"eventually"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented eventually: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex EVENTUALLY : %s\n", yytext); 
                  */
		    return(PS_EVENTUALLY);
                  }
		}
		
"reset"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented eventually: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex RESET : %s\n", yytext); 
                  */
		    return(PS_RESET);
                  }
		}
		
"change"  { 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented pointer: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
       		  /* 
                    fprintf(out, "\nllex: pointer: %s\n", yytext); 
                  */
		    return(PS_CHANGE); 
                  }
		} 

"exists"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented exists: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex EXISTS : %s\n", yytext); 
                  */
		    return(PS_EXISTS);
                  }
		}
"forall"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented forall: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex FORALL : %s\n", yytext); 
                  */
		    return(PS_FORALL);
                  }
		}
"weak"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented forall: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex WEAK : %s\n", yytext); 
                  */
		    return(PS_WEAK);
                  }
		}
"strong"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented forall: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex STRONG : %s\n", yytext); 
                  */
		    return(PS_STRONG);
                  }
		}
"with"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented forall: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex WITH : %s\n", yytext); 
                  */
		    return(PS_WITH);
                  }
		}
"on"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented forall: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex on : %s\n", yytext); 
                  */
		    return(PS_ON);
                  }
		}
"often"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented forall: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex FORALL : %s\n", yytext); 
                  */
		    return(PS_OFTEN);
                  }
		}
"almost"	{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented forall: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex FORALL : %s\n", yytext); 
                  */
		    return(PS_ALMOST);
                  }
		}
"true"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented true: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex true : %s\n", yytext); 
                  */
		    return(PS_TRUE);
                  }
		}
"false"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented false: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex false : %s\n", yytext); 
                  */
		    return(PS_FALSE);
                  }
		}
"NULL"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented NULL: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex null: %s\n", yytext); 
                  */
		    return(PS_NULL);
                  }
		}
"P"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented P: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex P: %s\n", yytext); 
                  */
		    return(PS_P);
                  }
		}
"implies"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented IMPLY: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex IMPLY : %s\n", yytext); 
                  */
		    return(PS_IMPLY);
                  }
		}
"("		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented LEFT(: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex LEFT( : %s\n", yytext); 
                  */
		    return(PS_LPAR);
                  }
		}
")"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented RIGHT): %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex RIGHT) : %s\n", yytext); 
                  */
		    return(PS_RPAR);
                  }
		}
"["		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented LEFT[: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex : %s\n", yytext); 
                  */
		    return(PS_LBRAC);
                  }
		}
"]"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented RIGHT]: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex right]: %s\n", yytext); 
                  */
		    return(PS_RBRAC);
                  }
		}
"{"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented LEFT{: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex LEFT{: %s\n", yytext);  
                  */
		    return(PS_LCURLY);
                  }
		}
"}"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented RIGHT}: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex RIGHT}: %s\n", yytext);  
                  */
		    return(PS_RCURLY);
                  }
		}
".."		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented COMMA: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex DDOTS: %s\n", yytext); 
                  */
		    return(PS_DDOTS);
                  }
		}
","		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented COMMA: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex COMMA: %s\n", yytext); 
                  */
		    return(PS_COMMA);
                  }
		}
"++"		{
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented increment: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex INCREMENT: %s\n", yytext); 
                  */
		    return(PS_INC);
                  }

		}
"--"		{
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented decrement: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex DECREMENT: %s\n", yytext); 
                  */
		    return(PS_DEC);
                  }

		}
"+"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented PLUS: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex PLUS: %s\n", yytext); 
                  */
		    return(PS_PLUS);
                  }
		}
"-"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented MINUS: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex MINUS: %s\n", yytext); 
                  */
		    return(PS_MINUS);
                  }
		}
"*"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented MULTIPLY: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex MULTIPLY: %s\n", yytext); 
                  */
		    return(PS_MULTIPLY);
                  }
		}
"/"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented DIVIDE: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex DIVIDE: %s\n", yytext); 
                  */
		    return(PS_DIVIDE);
                  }
		}
"<"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented LESS: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex LESS : %s\n", yytext);  
                  */
		    return(PS_LESS);
                  }
		}
"<="		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented LEQ: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex <=: %s\n", yytext);  
                  */
		    return(PS_LEQ);
                  }
		}
"=<"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented old LEQ: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                    fprintf(out, "\nError: an outdated LESS-THAN:''%s'' at line %1d\n", yytext, lineno); 
		    fprintf(out, "Sorry that we've changed the notation to ''<=''\n"); 
		    fprintf(out, "Please make appropriate changes in your input file.\n"); 
		    fflush(out); 
		    exit(23); 
                  }
		}
">"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented GREATER: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex GREATER: %s\n", yytext);  
                  */
		    return(PS_GREATER);
                  }
		}
">="		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented GEQ: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                  /*
                    fprintf(out, "lex GEQ : %s\n", yytext);  
                  */
		    return(PS_GEQ);
                  }
		}
"=>"		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented old GEQ: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		    fflush(out); 
		    exit(0); 
		  } 
                  else {
                    fprintf(out, "\nError: an outdated GREATER-THAN:''%s'' at line %1d\n", yytext, lineno); 
		    fprintf(out, "Sorry that we've changed the notation to ''>=''\n"); 
		    fprintf(out, "Please make appropriate changes in your input file.\n"); 
		    fflush(out); 
		    exit(23); 
                  }
		}

[0-9]+		{ 
		  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented NUMBER: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    if (flag_line_start == 3) { 
		      macro_register(gram_macro_name, atoi(yytext)); 
		      flag_line_start = FALSE; 
		    }
		    else { 
		      fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		      fflush(out); 
		      exit(0); 
		    }
		  } 
                  else {
		    flag_line_start = FALSE; 
                    yylval.number = atoi(yytext);
                  /*
		    fprintf(out, "lex NUMBER : %s\n", yytext); 
                  */
		    return(PS_NUMBER);
                  }
		}
[A-Za-z][A-Za-z0-9_\.]* {
		  char	*mname; 

                  if (depth_comment) { 
/*
                    fprintf(out, "\nllex: commented identifier: %s\n", yytext); 
                    fflush(out); 
*/
                  }
		  else if (flag_line_start > 1) {
		    if (flag_line_start == 2) { 
		      mname = (char *) malloc(strlen(yytext)+1); 
		      sprintf(mname, "%s", yytext); 
		      gram_macro_name = mname; 
		      flag_line_start = 3; 
		    }
		    else { 
		      fprintf(out, "Error in macro syntax at line %1d\n", lineno); 
		      fflush(out); 
		      exit(0); 
		    }
		  } 
                  else {
		    yylval.string = (char *) malloc((unsigned) strlen(yytext)+1);
		    strcpy(yylval.string, yytext); 

		    return(PS_IDENTIFIER);
                  }
		}
" "		{ 
		  if (flag_line_start == 1) 
		    flag_line_start = FALSE; 
		}
"\t"		{ 
		  if (flag_line_start == 1) 
		    flag_line_start = FALSE; 
		}
"\n"		{ 
		  lineno++; 
		  flag_line_start = 1; 
		}



%%




int	yywrap() 
{
  fclose(yyin); 
  return(1); 
}
/* yywrap() */ 


