/* Fischer's protocol with 3 processes */ 
process count = 3;

global discrete d0, d1, d2, d3: 0..1; 

local clock x; 

mode idle1 true {
  when true may x= 0; goto execute1; 
}

mode execute1 x<1 {
  when d0==1 may d1 = 1; goto idle1; 
  when d0==0 may goto idle1;  
}

mode idle2 true {
  when true may x= 0; goto execute2; 
}

mode execute2 x<1 {
  when d1==1 may d2 = 1; goto idle2; 
  when d1==0 may goto idle2;  
}

mode idle3 true {
  when true may x= 0; goto execute3; 
}

mode execute3 x<1 {
  when d2==1 may d3 = 1; goto idle3; 
  when d2==0 may goto idle3;  
}



initially 
   d0==1 && d1==0 && d2==0 && d3==0 
&& idle1[1] && idle2[2] && idle3[3]; 

tctl 
  forall strong {execute1[1]; execute2[2]; execute3[3];} 
    eventually (d0==1 && d1==1 && d2==1 && d3== 1);


