/* Fischer's protocol with 4 processes */ 
process count = 4;

global pointer lock; 

local clock x; 

mode idle true {
  when lock = null may x:= 0; goto ready; 
}

mode ready true {
  when x < 19 may x:= 0; lock:= P; goto waiting; 
}

mode waiting true { 
  when (x > 10 and lock = P) may goto critical; 
  when lock != P may goto idle; 
}

mode critical true { 
  when true may lock := null; goto idle; 
} 

initially 
lock = null and 
idle[1] and x[1] = 0 and 
idle[2] and x[2] = 0 and 
idle[3] and x[3] = 0 and 
idle[4] and x[4] = 0; 

risk (critical[1] and (critical[2] or critical[3] or critical[4]))
or   (critical[2] and (critical[3] or critical[4]))
or   (critical[3] and (critical[4]));


