process count = 5; 

global discrete L ;
global clock time;
local clock y; 
global synchronizer take, release;

/*** Viking 1 ***********************************************************
*/
mode v1_over true {
	when !release true may goto v1_unsafe; 
}

mode v1_ready true { 
	when y >= 5 may goto v1_over; 
}

mode v1_safe true { 
	when !take L==1 may y=0; goto v1_ready; 
}

mode v1_u_over true { 
	when !release true may goto v1_safe; 
}

mode v1_u_ready true { 
	when y >= 5 may goto v1_u_over; 
}

mode v1_unsafe true { 
	when !take L==0 may y= 0; goto v1_u_ready; 
}

/*** Viking 2 ***********************************************************
*/
mode v2_over true {
	when !release true may goto v2_unsafe; 
}

mode v2_ready true { 
	when y >= 10 may goto v2_over; 
}

mode v2_safe true { 
	when !take L==1 may y=0; goto v2_ready; 
}

mode v2_u_over true { 
	when !release true may goto v2_safe; 
}

mode v2_u_ready true { 
	when y >= 10 may goto v2_u_over; 
}

mode v2_unsafe true { 
	when !take L==0 may y= 0; goto v2_u_ready; 
}

/*** Viking 3 ***********************************************************
*/
mode v3_over true {
	when !release true may goto v3_unsafe; 
}

mode v3_ready true { 
	when y >= 15 may goto v3_over; 
}

mode v3_safe true { 
	when !take L==1 may y=0; goto v3_ready; 
}

mode v3_u_over true { 
	when !release true may goto v3_safe; 
}

mode v3_u_ready true { 
	when y >= 15 may goto v3_u_over; 
}

mode v3_unsafe true { 
	when !take L==0 may y= 0; goto v3_u_ready; 
}

/*** Viking 4 ***********************************************************
*/
mode v4_over true {
	when !release true may goto v4_unsafe; 
}

mode v4_ready true { 
	when y >= 20 may goto v4_over; 
}

mode v4_safe true { 
	when !take L==1 may y=0; goto v4_ready; 
}

mode v4_u_over true { 
	when !release true may goto v4_safe; 
}

mode v4_u_ready true { 
	when y >= 20 may goto v4_u_over; 
}

mode v4_unsafe true { 
	when !take L==0 may y= 0; goto v4_u_ready; 
}


/**(Torch)***************************************
*/
mode free1 true { 
	when ?take true may goto free2; 
}

mode free2 true { 
	when true may goto one; 
	when ?take true may goto two; 
}

mode one true {
	when ?release L == 0 may L= 1; goto free1; 
	when ?release L == 1 may L= 0; goto free1; 
}

mode two true { 
	when ?release true may goto one; 
} 



initially 
free1[1] && L == 0 && time == 0 
&& v1_unsafe[2] 
&& v2_unsafe[3] 
&& v3_unsafe[4] 
&& v4_unsafe[5] 
;

risk 
v1_safe[2] && 
v2_safe[3] && 
v3_safe[4] && 
v4_safe[5] && 
time <= 60; 



